package com.usky.fire.service;

import com.usky.common.core.bean.CommonPage;
import com.usky.common.mybatis.core.CrudService;
import com.usky.fire.domain.DemMicroStation;
import com.usky.fire.domain.DemWaterSource;
import com.usky.fire.service.po.FireWaterPO;
import com.usky.fire.service.vo.DemWaterSourceExportVO;
import com.usky.fire.service.vo.FireWaterStatisticsVO;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 水源信息表 服务类
 * </p>
 *
 * @author JCB
 * @since 2022-10-24
 */
public interface DemWaterSourceService extends CrudService<DemWaterSource> {

    /**
     * 消防水源管理-列表
     *
     * @param waterName 水源名称
     * @param id        主键ID
     * @param pageNum   当前页
     * @param pageSize  每页条数
     * @return
     */
    CommonPage<Map<String, Object>> waterSourceList(String waterName, Integer id, Integer pageNum, Integer pageSize);

    /**
     * 消防水源管理-列表-导出
     *
     * @param waterName 水源名称
     */
    List<DemWaterSourceExportVO> waterSourceListExport(String waterName);

    /**
     * 消防水源管理-修改
     *
     * @param demWaterSource
     */
    void updateWaterSource(DemWaterSource demWaterSource);

    /**
     * 消防水源管理-删除
     *
     * @param id 主键ID
     */
    void delWaterSource(Integer id);

    List<Object> waterSourceList(String streetTown);

    List<DemWaterSource> waterSourceList();

    List<Map<String, Object>> surroundingResources(double longitude, double latitude, Integer distance);

    List<Object> waterSourceScatterer(String scattererType, String streetTown);

    List<DemMicroStation> microStationScatterer();

    int waterSourceCount(String waterType, String waterNature, String waterForm, String startTime, String endTime, String availableStatus);

    FireWaterStatisticsVO getFireWaterStatistics(String startTime, String endTime);

    CommonPage<FireWaterPO> page(Integer current, Integer size, String startTime, String endTime);
}
